/****************************************************************************
* NVMC                                                                      *
* Visual and Computer Graphics Library                                      *
*                                                                           *
* Copyright(C) 2007                                                         *
* ISTI - Italian National Research Council                                  *
*                                                                           *
* All rights reserved.                                                      *
*                                                                           *
* This program is free software; you can redistribute it and/or modify      *   
* it under the terms of the GNU General Public License as published by      *
* the Free Software Foundation; either version 2 of the License, or         *
* (at your option) any later version.                                       *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License (http://www.gnu.org/licenses/gpl.txt)          *
* for more details.                                                         *
*                                                                           *
****************************************************************************/
/****************************************************************************
  History

$Log: game_viewer.cpp,v $
Revision 1.31  2007/04/10 18:55:37  gian_lorenzo
FINAL RELEASE (aggiustate le normali nei palazzi)

Revision 1.30  2007/04/10 17:57:26  gian_lorenzo
FINAL RELEASE

Revision 1.29  2007/04/10 17:07:09  gian_lorenzo
*** empty log message ***

Revision 1.28  2007/04/10 14:42:52  gian_lorenzo
*** empty log message ***

Revision 1.27  2007/04/10 14:09:53  gian_lorenzo
*** empty log message ***

Revision 1.26  2007/04/10 10:14:42  gian_lorenzo
*** empty log message ***

Revision 1.25  2007/04/10 09:56:04  gian_lorenzo
*** empty log message ***

Revision 1.24  2007/04/09 11:33:23  gian_lorenzo
*** empty log message ***

Revision 1.23  2007/04/07 13:35:33  gian_lorenzo
skybox
headlight con texture proiettiva
cube mapping
palazzi

Revision 1.22  2007/04/07 08:29:34  gian_lorenzo
*** empty log message ***

Revision 1.21  2007/04/06 13:46:48  gian_lorenzo
*** empty log message ***

Revision 1.20  2007/04/06 06:47:17  gian_lorenzo
*** empty log message ***

Revision 1.19  2007/04/04 18:11:47  gian_lorenzo
*** empty log message ***

Revision 1.18  2007/04/04 13:52:37  gian_lorenzo
*** empty log message ***

Revision 1.17  2007/04/04 09:58:04  gian_lorenzo
*** empty log message ***

Revision 1.16  2007/04/04 08:11:29  gian_lorenzo
*** empty log message ***

Revision 1.15  2007/04/04 07:26:53  gian_lorenzo
*** empty log message ***

Revision 1.14  2007/04/03 19:21:16  gian_lorenzo
*** empty log message ***

Revision 1.13  2007/04/03 15:00:14  gian_lorenzo
*** empty log message ***

Revision 1.12  2007/04/03 13:33:10  gian_lorenzo
*** empty log message ***

Revision 1.11  2007/04/03 09:32:06  gian_lorenzo
*** empty log message ***

Revision 1.10  2007/04/02 17:03:47  gian_lorenzo
*** empty log message ***

Revision 1.9  2007/03/31 14:35:54  gian_lorenzo
*** empty log message ***

Revision 1.8  2007/03/22 19:05:00  gian_lorenzo
*** empty log message ***

Revision 1.7  2007/03/22 09:00:09  gian_lorenzo
*** empty log message ***

Revision 1.6  2007/03/20 18:14:05  gian_lorenzo
*** empty log message ***

Revision 1.5  2007/03/20 16:15:25  gian_lorenzo
*** empty log message ***

Revision 1.4  2007/03/19 23:35:02  gian_lorenzo
*** empty log message ***

Revision 1.3  2007/03/19 18:51:14  gian_lorenzo
*** empty log message ***

Revision 1.2  2007/03/19 09:28:33  gian_lorenzo
*** empty log message ***

Revision 1.1  2007/03/18 18:26:50  gian_lorenzo
*** empty log message ***

Revision 1.3  2007/03/11 18:11:59  ganovelli
minor modif


****************************************************************************/

#include <SDL.h>
#include <math.h>
#include <time.h>
#include <vcg/space/point3.h>
#include <vector>
#include <GL/glew.h>
#include <GL/glut.h>
#include <GL/glu.h>

#include "../client/game_client.h"
#include "game_viewer.h"
#include "mycar.h"
#include "util.h"
#include "tunnel.h"
#include "race.h"

/** Client  */
extern  NvmcClient cli;

/* value of pi */
#define M_PI       3.14159265358979323846

static int last_rendering = 0;
/** viewport size */
int width,height;
GLfloat mat_lig[32];

// The light is always at the current origin.
const GLfloat light_pos[] = { 0.0, 0.0, 0.0, 1.0 };
GLfloat sun_pos[4] = { 0.0, 0.0, 0.0, 0.0 };

// shader
GLuint vs,fs,pr;

// Colours and properties of materials.
const GLfloat white[] = { 1.0, 1.0, 1.0, 1.0 };
const GLfloat earth[] = { 0.5f, 0.5f, 0.5f, 1.0 };
const GLfloat sun[] = { 0.95f, 0.95f, 0.9f, 1.0 };
const GLfloat black[] = { 0.15, 0.15, 0.15, 1.0 };
const GLfloat polished[] = { 15.0 };
const GLfloat dull[] = { 0.0 };

/** Display List del circuito */
GLuint CircuitDL,CarDL;

bool fari;

void init_lights(){
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
}

/** inizializzazione lo stato di opengl */
void init_opengl(){
	glShadeModel(GL_SMOOTH);
	glEnable(GL_NORMALIZE);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LESS);

	//glBlendFunc(GL_ONE, GL_SRC_ALPHA);
	glBlendFunc(GL_SRC_ALPHA, GL_DST_ALPHA);
	glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER, 0); 
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	//glEnable(GL_CULL_FACE);
	//glCullFace(GL_BACK);
	glPolygonMode(GL_FRONT,GL_FILL); // riempi i poligoni
	glDepthRange(0,1);
	glClearDepth(1.0);
	init_lights();
	skyInit();
}

/** callback function for viewport resize.*/
void resize_screen(int w, int h){
	width = w;
	height = h;
	glViewport(0,0,width,height);
}

void gl_print(float x, float y, const char *str) {
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	glColor3f(1.0,1.0,1.0);
	glRasterPos2f(x, y);
	int len = (int)strlen(str);
	for(int i = 0; i < len; i++) 
		glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, str[i]);
	glEnable(GL_LIGHTING);
	glEnable(GL_TEXTURE_2D);
}

/** render the scene */
void draw_scene(){
	int i=0,j=0,k=0;
	static int cn = 0;
	static int part = 0;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	vcg::Point4f sun_position=race.circuit->sun_position;
	sun_pos[0]=sun_position.X();
	sun_pos[1]=sun_position.Y();
	sun_pos[2]=sun_position.Z();
	sun_pos[3]=1.0;

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	/* here take the bounding box of the whole circuit */
	vcg::Point3f bmin = race.circuit->bbox.min;
	vcg::Point3f bmax = race.circuit->bbox.max;

	float sidex,sidez;
	sidex = bmax[0]-bmin[0];
	sidez = bmax[2]-bmin[2];

	/* updte the state of the players as received by the server */
	cli.UpdatePlayers();

	Race::PlayersIterator fpi;
	vcg::Point3f position=vcg::Point3f(0,0,0);
	vcg::Point3f delta=vcg::Point3f(0,0,0);
	vcg::Point3f delta2=vcg::Point3f(0,0,0);
	vcg::Point3f delta3=vcg::Point3f(0,0,0);
	if(cli.players.size()>0){
		fpi=cli.players.begin();
		Frame myf=(*fpi).car.frame;
		position=myf.GetRow3(3);
		//delta=-myf.GetRow3(2)*5.0+myf.GetRow3(1)*0.1;
		delta=myf.GetRow3(2)*3.0+myf.GetRow3(1)*0.7;
		delta2=-myf.GetRow3(2)+myf.GetRow3(1)*0.7;
	}

	gluPerspective(45,width/(float)height,0.1,700);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	vcg::Point3f pov=position + delta;
	vcg::Point3f pov2=position + delta2;
	
	gluLookAt(pov.X(),pov.Y(),pov.Z(),pov2.X(),pov2.Y(),pov2.Z(),0,1,0);

	// calcolo la direzione del sole rispetto al pov
	vcg::Point3f sun3f(sun_position.X(),sun_position.Y(),sun_position.Z());
	float angle=vcg::math::Acos((sun3f-pov).Normalize()*vcg::Point3f(-1,0,0));

	// draw sky texture
	skyDraw(pov,angle);

	if(fari){
		headlight(vcg::Point3f(0,3.0,-3.0),vcg::Point3f(0,0,-7.0));
	}

	// draw the sun
	glPushMatrix();
		glTranslatef(sun_pos[0], sun_pos[1], sun_pos[2]);
		glLightfv(GL_LIGHT0, GL_AMBIENT_AND_DIFFUSE, sun);
		glLightfv(GL_LIGHT0, GL_SPECULAR, sun);
		// Now move the light to the position of the sun to illuminate the plane.
		glLightfv(GL_LIGHT0, GL_POSITION, light_pos);
	glPopMatrix();
	// Set model properties for terrain and render it.
	glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, white);
	glMaterialfv(GL_FRONT, GL_SPECULAR, white);
	glMateriali(GL_FRONT, GL_SHININESS, 0.5);

	if(fari)setHeadlight(position-pov,pov2);

	// draw bounding box of the terrain
	glBindTexture(GL_TEXTURE_2D,104);
	glBegin(GL_QUADS);
	glNormal3f(0.0,1.0,0.0);
	glTexCoord2f(0.0,0.0);
	glVertex3f(bmin[0],bmin[1]-0.5,bmin[2]);
	glTexCoord2f(0.0,300.0);
	glVertex3f(bmax[0],bmin[1]-0.5,bmin[2]);
	glTexCoord2f(300.0,0.0);
	glVertex3f(bmax[0],bmin[1]-0.5,bmax[2]);
	glTexCoord2f(300.0,300.0);
	glVertex3f(bmin[0],bmin[1]-0.5,bmax[2]);
	glEnd();
	
	// draw building
	Circuit::BuildingsIterator s;
	std::vector<vcg::Point3f> palace;
	for(s=race.circuit->buildings.begin();s!=race.circuit->buildings.end();s++){
		float height=s->height;
		std::vector<Vertex> list= s->footprint;
		buildPalace(list,&palace,height);
		drawPalace(palace);
	}
	
	// draw circuit
	glCallList(CircuitDL);

	// draw tree
	tree(pov);

	// draw tunnel
	bool inTunnel=IsInTunnel(position);
	if(inTunnel)glDisable(GL_LIGHT0);
	else glEnable(GL_LIGHT0);
	drawTunnels(position,pov,pov2);

	// draw players
	Race::PlayersIterator pi= cli.players.begin();
	int st = clock();
	for(pi = cli.players.begin(); pi != cli.players.end(); ++pi)
		{
			glPushMatrix();
			// apply transformation coded in the frame
			Frame f = ((*pi).car.frame);
			glMultMatrixf(&f[0][0]);
			glPushMatrix();

			if(!inTunnel)skyEnable();
			glCallList(CarDL);
			if(!inTunnel)skyDisable();
			
			glPopMatrix();
			gl_print(0.0,0.5,(*pi).ip_address.c_str()); // write the IP address of the client
			glPopMatrix();
	 }

	if(fari){
		glDisable(GL_LIGHT1);
		headlightDisable();
	}

	//glDisable(GL_TEXTURE_2D);
	glLoadIdentity();
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	/* print the commands */
	gl_print(-1,0.8,"accel: UP");
	gl_print(-1,0.7,"retro: DOWN");
	gl_print(-1,0.6,"left:  <-");
	gl_print(-1,0.5,"right: ->");
	gl_print(-1,0.4,"brake: SPACE");
	gl_print(-1,0.3,"reset: p");

	SDL_GL_SwapBuffers();
	cn++;
	if(clock()-part >1000){	
		printf("VIEW fps %d\n",cn);
		part = clock();
		cn=0;
	}
}

/// callback function che gestisce l'evento "mouse mosso"
void mouse_move(SDL_Event e){
}
///

void keydown(SDL_Event e){
	switch(e.key.keysym.sym){
		case SDLK_UP: cli.Command(COMMAND_INCREASE_SPEED);break;
		case SDLK_DOWN: cli.Command(COMMAND_DECREASE_SPEED);break;
		case SDLK_LEFT: cli.Command(COMMAND_TURN_LEFT);break;
		case SDLK_RIGHT: cli.Command(COMMAND_TURN_RIGHT);break;
		case SDLK_SPACE: cli.Command(COMMAND_BRAKE);break;
		case SDLK_a: fari=!fari;break;
		case SDLK_p: cli.Command(COMMAND_RESTART);break;
	}
}
///
int launch_viewer(){
	fari=false;
  // inizializzazione di SDL  
  SDL_Init( SDL_INIT_VIDEO ); 
  
  // facciamo una finestra di 600x600
  SDL_SetVideoMode(600,600,0, SDL_OPENGL);

  // carico il modello macchina
  if(!load_car()){
	  printf("Errore nel caricamento del modello della macchina\n");
	  int a=0;
	  scanf("%d",&a);
	  exit(1);
  }

  // inizializzamo lo stato di opengl
  glewInit();
  init_opengl();
  
  glActiveTexture(GL_TEXTURE1);
  loadTexture("../../client5/headlight3.bmp",1,1);
  glActiveTexture(GL_TEXTURE0);
  loadTexture("../../client5/fractures.bmp",2,0);
  loadTexture("../../client5/build2.bmp",3,0);
  loadTexture("../../client5/tree.bmp",4,1);
  loadTexture("../../client5/tunnel_0.bmp",5,0);
  loadTexture("../../client5/tunnel_1.bmp",6,0);
  loadTexture("../../client5/skybox2/neg_z.bmp",100,0);
  loadTexture("../../client5/skybox2/neg_x.bmp",101,0);
  loadTexture("../../client5/skybox2/pos_x.bmp",102,0);
  loadTexture("../../client5/skybox2/pos_y.bmp",103,0);
  loadTexture("../../client5/skybox2/neg_y.bmp",104,0);
  loadTexture("../../client5/skybox2/pos_z.bmp",105,0);

  // carico il circuito
  CircuitDL = circuitDraw();
  // carico la macchina
  CarDL = compileCar();
  // carico i tunnels
  loadTunnels();

  // inizializzo shader
  //set_shaders("../../client5/opengl.vert","../../client5/opengl.frag",vs,fs,pr);
  //glUseProgram(pr);

  // settiamo OpenGL alle dimensioni 600x600
  resize_screen(600,600);

  static int last_rendering = 0;
  int done=0;
  bool command=false;
  while (!done) { // loop gestione eventi
    
    SDL_Event e;
 
		// guarda se c' un evento. Che ci sia o no continua
    if(SDL_PollEvent(&e))
			// processo l'evento
			switch (e.type) {
				case SDL_KEYDOWN: 
					  keydown(e);
					break;
				case SDL_VIDEORESIZE:  
					// evento: a dim della finestra e' cambiata
					resize_screen(e.resize.w,e.resize.h);
					break;
	        
				case SDL_QUIT:  
					// evento: la applicazione deve uscire
					done=1;   
					break;
				}
	/* temporizzazione del rendering: rendere il refresh machine independent*/
		if(clock()-last_rendering>20){
			last_rendering = clock();
			command=false;
			draw_scene();
		}
  }
	return 0;
}
